# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2010-2011, Tashilgostar co. , All Rights Reserved
#        Nima ghorbani <nima.ghorbani@tashilgostar.com> (http://tashilgostar.com)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import time
import subprocess
import netsvc
import pooler
from osv.orm import browse_record
import shutil


import base64
import sys,os,random
debug = True

import netsvc
import pooler
import tools
from osv.orm import browse_record
import cups_commander

from osv import fields, osv
from tools.translate import _

import unzip,os



cmd=cups_commander.cups_cmd

class printers_print(osv.osv_memory):
    """ Print Documents"""
    _name = "printers.print"
    _description = "Print Documents"
    _columns = {   
        'attachment' : fields.binary('Document', filters='*.*,*.pdf,*.doc,*.docx,*.zip',required=True),
        'name' : fields.char('name', size=128, required=True),
        'att_type' : fields.char('Type', size=128, required=True),
        'noofcopy' : fields.integer('No. of copies', size=512,required=True),
        'printer_id' : fields.many2one('printers', 'Printer', required=True),
        'fit': fields.boolean('Fit', help="Select this if you want to fit the document to the page borders.",value=True), 
        'one_side': fields.boolean('One Side Print'), 
        'two_side': fields.boolean('Two Side Print'),
        'landscape': fields.boolean('Landscape'),
        'letter': fields.boolean('Letter'),
        'A3': fields.boolean('A3'),
        'message': fields.text('Message'),
        'state':fields.selection([
            ('first','First'),
            ('done','Done'),
            ],'State'),
    }
    _defaults = {
        'state': lambda *a: 'first',
        'one_side': lambda *a: True,
        'fit': lambda *a: True,
        'noofcopy': lambda *a: 1,
    }
    def view_init(self, cr, uid, fields, context=None):
        raise ImportError
    def u(self,obj, encoding='utf-8'):
        if isinstance(obj, basestring):
            if not isinstance(obj, unicode):
                obj = unicode(obj, encoding)
        return obj
    def get_suffix(self,fname):
        suffix=fname.split('.')
        if len(suffix)!=2:raise osv.except_osv(_('Printer Manger - Error!'), _('Should not use "." in filename %s!!!' % fname))
        return suffix[0],suffix[1].lower()
    def convert_office(self,tempf):
        print "Trying to convert this file",tempf
        cmdconv='unoconv -f pdf '+tempf
        pipe = subprocess.Popen(cmdconv, stdout=subprocess.PIPE,stderr=subprocess.PIPE, shell=True)
        sts = pipe.wait()
        err= pipe.stderr.read()
        print err
        if err: raise osv.except_osv(_('Printer Manger - Error!'), _('The provided document cannot be converted to the desired format.'))

    def cups_print(self,printer,form):
        cmdcups = cups_commander.build_cups_cmd(self, printer, form).encode('utf8')
        out=''
        pipe = subprocess.Popen(cmdcups, stdout=subprocess.PIPE,stderr=subprocess.PIPE, shell=True)
        sts = pipe.wait()
        out= pipe.stdout.read() + pipe.stderr.read()
        print out

    def pprint(self, cr, uid, ids, datas, context={}):
        """
        This function load column.
        @param cr: the current row, from the database cursor,
        @param uid: the current users ID for security checks,
        @param ids: List of load column,
        @return: dictionary of query logs clear message window
        """
        nbOk = 0
        logger = netsvc.Logger()
        pool = pooler.get_pool(cr.dbname)
        form = self.browse(cr, uid, ids[0])
        pool = pooler.get_pool(cr.dbname)
        printer = pool.get('printers').browse(cr, uid,int(form.printer_id))
        if form.name:
            fname,suffix=self.get_suffix(form.name)
            origf_name = "/tmp/" + str(random.randint(0,100))
            origf=origf_name+'.'+suffix
            with open(origf, "wb") as pf:
                pf.write(base64.decodestring(form.attachment))
            if suffix =='pdf':
                form.attachment=origf  
                out = self.cups_print(printer,form)
                nbOk+=1
                values = {
                    'message':_(u'%s مورد پرینت به پرینتر مورد نظر ارسال شد. ') %nbOk,
                    'state':'done',}
                self.write(cr, uid, ids, values)
                return  
            if suffix!='zip':
                try:
                    temp_pf=form.name
                    self.convert_office(origf)
                    nbOk+=1
                    values = {
                        'message':_(u'%s مورد پرینت به پرینتر مورد نظر ارسال شد. ') %nbOk,
                        'state':'done',}
                except:
                    values = {
                        'message':_('%s مورد پرینت به پرینتر مورد نظر ارسال شد. \n خطا در مورد فایلهای زیر :\n  %s \n سعی کنید در حالت پی دی اف امتحان نمایید.') %(nbOk,temp_pf),
                        'state':'done',}
                    self.write(cr, uid, ids, values)
                    return 
                form.attachment=origf_name+'.pdf'   
                out = self.cups_print(printer,form)
                self.write(cr, uid, ids, values)
                return  
            if suffix=='zip':
                err=''
                unzipper = unzip.unzip()
                new_origf=origf_name+'2/'
                zipsource,zipdest= origf,new_origf
                unzipper.extract(zipsource, zipdest)
                k=os.listdir(new_origf)
                for pf in k:
                    if pf:
                        temp_pf=pf
                        fname,suffix=self.get_suffix(pf)
                        new_name = str(random.randint(0,100))
                        os.rename(new_origf+pf,new_origf+new_name+'.'+suffix)
                        pf=new_name+'.'+suffix
                        fname,suffix=self.get_suffix(pf)
                        if suffix!='pdf':
                            try:
                                self.convert_office(new_origf+pf)
                                nbOk+=1
                            except:
                                err+='\n'+temp_pf
                                continue
                        else:nbOk+=1
                        form.attachment=new_origf+fname+'.pdf'
                        out=self.cups_print(printer,form)
                if err=='':
                    values = {
                        'message':_(u'%s مورد پرینت به پرینتر مورد نظر ارسال شد. ') %nbOk,
                        'state':'done',}
                else:
                    values = {
                        'message':_('%s مورد پرینت به پرینتر مورد نظر ارسال شد. \n خطا در مورد فایلهای زیر :\n  %s \n سعی کنید در حالت پی دی اف امتحان نمایید.') %(nbOk,origf),
                        'state':'done',}
                self.write(cr, uid, ids, values)
                shutil.rmtree(new_origf)
                return 
            #try:

            #except IOError:
                #raise osv.except_osv(_('Printer Manger - Error!'), _('Unable to open temporary file for file attachement: %s !!!' % printf))

printers_print()
class printers_result(osv.osv_memory):
    _name = "printers.result"
    _description = "Print Results"
    _columns = {   
        'sent' : fields.integer('Sent to printer', readonly= True),
        'not_sent' : fields.integer('Not sent', readonly= True),
    }


    def view_init(self, cr, uid, fields, context=None):
        """
        This function checks for precondition before wizard executes
        @param self: The object pointer
        @param cr: the current row, from the database cursor,
        @param uid: the current user’s ID for security checks,
        @param fields: List of fields for default value
        @param context: A standard dictionary for contextual values
        """
        return {'sent':context.get('sent',0),'not_sent':context.get('not_sent',0)}
printers_result()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

